

import sys
import getopt
import skparser
import rwintfc

##########################################################################
# global parser object

par = None

##########################################################################

class Redirect:
    def __init__(self):
        pass
    
    def write(self, s, lineno=-1):
        pass

class StdoutRedirect(Redirect):
    def __init__(self):
        Redirect.__init__(self)
        
    def write(self, s, lineno=-1):
        print s
 
##########################################################################

def usage():   
    print sys.argv[0], "-i infile [-o=<outfile> -p=<pagewidth>",
    print " -b=<blockindent> -c=<contindent>]"
    sys.exit(2)
 
def reloaddefs():
    global par
    if par == None:
        par = skparser.SkParser()
    reload(rwintfc)   
    rwintfc.initRWIntfcObjs(par)
    
##########################################################################
        
def guiintfc(file, redirbuff, blockindent=4, \
        prettyprint=False, pagewidth=200, contindent=2, trace=False):
    global par
    infile = file

    if par == None:
        par = skparser.SkParser()
    rwintfc.initRWIntfcObjs(par)
    
    # turn on debug
    if trace == True:
        par.toggleTrace()
    
    try:
        stmts = par.parse_file(infile)
    except skparser.SkLexerError:
        print "error during lexical analysis.  exiting."
    except skparser.SkParserError, msg:
        print "error during input parsing.  "
        print msg
        print "  exiting."
    else:
        if prettyprint == True:
            prbuff.setchannel(redirbuff)
            
        par.configure(margin=pagewidth, contindent=contindent, 
              blockindent=blockindent)
        for stmt in stmts:
            if prettyprint == True:
                stmt.pppython(redirbuff)               
            else:
                stmt.emit(redirbuff)
            
########################################################################   
    
def translate(argv):
    # defaults....
    # infile = r"C:\Documents and Settings\dan.AMD64-X2\Desktop\sk2py\pcells\test.il"
    infile=""
    pagewidth=200
    blockindent=4
    contindent=2

    try:                                
        opts, args = getopt.getopt(argv, "hiopbc", 
               ["help", "infile=", "outfile=", "pagewidth=", "blockindent=", "contindent="]) 
    except getopt.GetoptError:           
        usage()                          
        sys.exit(2)
        
    for opt, arg in opts:                
        if opt in ("-h", "--help"):      
            usage()                     
            sys.exit()                  
        elif opt in ("-i", "--infile"): 
            infile = arg                  
        elif opt in ("-o", "--outfile"): 
            outfile = arg                        
        elif opt in ("-w", "--width"): 
            pagewidth = arg           
        elif opt in ("-c", "--blockindent"): 
            blockindent = arg                               
        elif opt in ("-c", "--contindent"): 
            contindent = arg 

    if par == None:
        par = skparser.SkParser()
                          
    rwintfc.initRWIntfcObjs(par)
    
    # turn on debug
    par.toggleTrace()
    
    try:
        stmts = par.parse_file(infile)
    except skparser.SkLexerError:
        print "error during lexical analysis.  exiting."
        sys.exit(2)
    except skparser.SkParserError, msg:
        print "error during input parsing.  "
        print msg
        print "exiting."
        sys.exit(2)
    except:
        print "error during input parsing.  exiting."
        sys.exit(2)
    else:
        print "\n\n" + "#"*pagewidth
        print "margin set to " + str(pagewidth) + "\n\n"

#        try: 
        par.configure(margin=pagewidth, contindent=contindent, 
              blockindent=blockindent)
        
        outbuff = StdoutRedirect()
        
        for stmt in stmts:
            if prettyprint == True:
                stmt.pppython(outbuff)               
            else:
                stmt.emit(outbuff)
           
if __name__ == "__main__":
    translate(sys.argv[1:])
    #infile = r"C:\Documents and Settings\dan.AMD64-X2\Desktop\sk2py\pcells\m1_n.il"
    #outbuff = StdoutRedirect()
    #guiintfc(infile, outbuff)
        

    
    
       
              